// ##### ENDFILE "CPUExecutionCapChangedEventWrap.cpp"


// ##### BEGINFILE "GuestMultiTouchEventWrap.cpp"
/** @file
 * VirtualBox API class wrapper code for IGuestMultiTouchEvent.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/**
 * Copyright (C) 2010-2016 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#define LOG_GROUP_MAIN_OVERRIDE LOG_GROUP_MAIN_GUESTMULTITOUCHEVENT

#include "GuestMultiTouchEventWrap.h"
#include "Logging.h"
#ifdef VBOX_WITH_DTRACE_R3_MAIN
# include "dtrace/VBoxAPI.h"
#endif

DEFINE_EMPTY_CTOR_DTOR(GuestMultiTouchEventWrap)

//
// IEvent properties
//

STDMETHODIMP GuestMultiTouchEventWrap::COMGETTER(Type)(VBoxEventType_T *aType)
{
    LogRelFlow(("{%p} %s: enter aType=%p\n", this, "GuestMultiTouchEvent::getType", aType));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aType);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_TYPE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getType(aType);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_TYPE_RETURN(this, hrc, 0 /*normal*/,*aType);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_TYPE_RETURN(this, hrc, 1 /*hrc exception*/,*aType);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_TYPE_RETURN(this, hrc, 9 /*unhandled exception*/,*aType);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aType=%RU32 hrc=%Rhrc\n", this, "GuestMultiTouchEvent::getType", *aType, hrc));
    return hrc;
}

STDMETHODIMP GuestMultiTouchEventWrap::COMGETTER(Source)(IEventSource **aSource)
{
    LogRelFlow(("{%p} %s: enter aSource=%p\n", this, "GuestMultiTouchEvent::getSource", aSource));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aSource);
        ComTypeOutConverter<IEventSource> TmpSource(aSource);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_SOURCE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getSource(TmpSource.ptr());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_SOURCE_RETURN(this, hrc, 0 /*normal*/,(void *)TmpSource.ptr());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_SOURCE_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_SOURCE_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aSource=%p hrc=%Rhrc\n", this, "GuestMultiTouchEvent::getSource", *aSource, hrc));
    return hrc;
}

STDMETHODIMP GuestMultiTouchEventWrap::COMGETTER(Waitable)(BOOL *aWaitable)
{
    LogRelFlow(("{%p} %s: enter aWaitable=%p\n", this, "GuestMultiTouchEvent::getWaitable", aWaitable));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aWaitable);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_WAITABLE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getWaitable(aWaitable);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_WAITABLE_RETURN(this, hrc, 0 /*normal*/,*aWaitable != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_WAITABLE_RETURN(this, hrc, 1 /*hrc exception*/,*aWaitable != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_WAITABLE_RETURN(this, hrc, 9 /*unhandled exception*/,*aWaitable != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aWaitable=%RTbool hrc=%Rhrc\n", this, "GuestMultiTouchEvent::getWaitable", *aWaitable, hrc));
    return hrc;
}

//
// IGuestMultiTouchEvent properties
//

STDMETHODIMP GuestMultiTouchEventWrap::COMGETTER(ContactCount)(LONG *aContactCount)
{
    LogRelFlow(("{%p} %s: enter aContactCount=%p\n", this, "GuestMultiTouchEvent::getContactCount", aContactCount));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aContactCount);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTCOUNT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getContactCount(aContactCount);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTCOUNT_RETURN(this, hrc, 0 /*normal*/,*aContactCount);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTCOUNT_RETURN(this, hrc, 1 /*hrc exception*/,*aContactCount);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTCOUNT_RETURN(this, hrc, 9 /*unhandled exception*/,*aContactCount);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aContactCount=%RI32 hrc=%Rhrc\n", this, "GuestMultiTouchEvent::getContactCount", *aContactCount, hrc));
    return hrc;
}

STDMETHODIMP GuestMultiTouchEventWrap::COMGETTER(XPositions)(ComSafeArrayOut(SHORT, aXPositions))
{
    LogRelFlow(("{%p} %s: enter aXPositions=%p\n", this, "GuestMultiTouchEvent::getXPositions", aXPositions));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aXPositions);
        ArrayOutConverter<SHORT> TmpXPositions(ComSafeArrayOutArg(aXPositions));
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_XPOSITIONS_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getXPositions(TmpXPositions.array());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_XPOSITIONS_RETURN(this, hrc, 0 /*normal*/,(uint32_t)TmpXPositions.array().size(), NULL /*for now*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_XPOSITIONS_RETURN(this, hrc, 1 /*hrc exception*/,0, 0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_XPOSITIONS_RETURN(this, hrc, 9 /*unhandled exception*/,0, 0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aXPositions=%zu hrc=%Rhrc\n", this, "GuestMultiTouchEvent::getXPositions", ComSafeArraySize(*aXPositions), hrc));
    return hrc;
}

STDMETHODIMP GuestMultiTouchEventWrap::COMGETTER(YPositions)(ComSafeArrayOut(SHORT, aYPositions))
{
    LogRelFlow(("{%p} %s: enter aYPositions=%p\n", this, "GuestMultiTouchEvent::getYPositions", aYPositions));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aYPositions);
        ArrayOutConverter<SHORT> TmpYPositions(ComSafeArrayOutArg(aYPositions));
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_YPOSITIONS_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getYPositions(TmpYPositions.array());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_YPOSITIONS_RETURN(this, hrc, 0 /*normal*/,(uint32_t)TmpYPositions.array().size(), NULL /*for now*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_YPOSITIONS_RETURN(this, hrc, 1 /*hrc exception*/,0, 0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_YPOSITIONS_RETURN(this, hrc, 9 /*unhandled exception*/,0, 0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aYPositions=%zu hrc=%Rhrc\n", this, "GuestMultiTouchEvent::getYPositions", ComSafeArraySize(*aYPositions), hrc));
    return hrc;
}

STDMETHODIMP GuestMultiTouchEventWrap::COMGETTER(ContactIds)(ComSafeArrayOut(USHORT, aContactIds))
{
    LogRelFlow(("{%p} %s: enter aContactIds=%p\n", this, "GuestMultiTouchEvent::getContactIds", aContactIds));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aContactIds);
        ArrayOutConverter<USHORT> TmpContactIds(ComSafeArrayOutArg(aContactIds));
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTIDS_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getContactIds(TmpContactIds.array());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTIDS_RETURN(this, hrc, 0 /*normal*/,(uint32_t)TmpContactIds.array().size(), NULL /*for now*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTIDS_RETURN(this, hrc, 1 /*hrc exception*/,0, 0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTIDS_RETURN(this, hrc, 9 /*unhandled exception*/,0, 0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aContactIds=%zu hrc=%Rhrc\n", this, "GuestMultiTouchEvent::getContactIds", ComSafeArraySize(*aContactIds), hrc));
    return hrc;
}

STDMETHODIMP GuestMultiTouchEventWrap::COMGETTER(ContactFlags)(ComSafeArrayOut(USHORT, aContactFlags))
{
    LogRelFlow(("{%p} %s: enter aContactFlags=%p\n", this, "GuestMultiTouchEvent::getContactFlags", aContactFlags));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aContactFlags);
        ArrayOutConverter<USHORT> TmpContactFlags(ComSafeArrayOutArg(aContactFlags));
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTFLAGS_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getContactFlags(TmpContactFlags.array());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTFLAGS_RETURN(this, hrc, 0 /*normal*/,(uint32_t)TmpContactFlags.array().size(), NULL /*for now*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTFLAGS_RETURN(this, hrc, 1 /*hrc exception*/,0, 0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_CONTACTFLAGS_RETURN(this, hrc, 9 /*unhandled exception*/,0, 0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aContactFlags=%zu hrc=%Rhrc\n", this, "GuestMultiTouchEvent::getContactFlags", ComSafeArraySize(*aContactFlags), hrc));
    return hrc;
}

STDMETHODIMP GuestMultiTouchEventWrap::COMGETTER(ScanTime)(ULONG *aScanTime)
{
    LogRelFlow(("{%p} %s: enter aScanTime=%p\n", this, "GuestMultiTouchEvent::getScanTime", aScanTime));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aScanTime);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_SCANTIME_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getScanTime(aScanTime);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_SCANTIME_RETURN(this, hrc, 0 /*normal*/,*aScanTime);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_SCANTIME_RETURN(this, hrc, 1 /*hrc exception*/,*aScanTime);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_GET_SCANTIME_RETURN(this, hrc, 9 /*unhandled exception*/,*aScanTime);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aScanTime=%RU32 hrc=%Rhrc\n", this, "GuestMultiTouchEvent::getScanTime", *aScanTime, hrc));
    return hrc;
}


//
// IEvent methods
//

STDMETHODIMP GuestMultiTouchEventWrap::SetProcessed()
{
    LogRelFlow(("{%p} %s:enter\n", this, "GuestMultiTouchEvent::setProcessed"));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {



#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_SETPROCESSED_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setProcessed();
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_SETPROCESSED_RETURN(this, hrc, 0 /*normal*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_SETPROCESSED_RETURN(this, hrc, 1 /*hrc exception*/);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_SETPROCESSED_RETURN(this, hrc, 9 /*unhandled exception*/);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "GuestMultiTouchEvent::setProcessed", hrc));
    return hrc;
}

STDMETHODIMP GuestMultiTouchEventWrap::WaitProcessed(LONG aTimeout,
                                                     BOOL *aResult)
{
    LogRelFlow(("{%p} %s:enter aTimeout=%RI32 aResult=%p\n", this, "GuestMultiTouchEvent::waitProcessed", aTimeout, aResult));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aResult);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_WAITPROCESSED_ENTER(this, aTimeout);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = waitProcessed(aTimeout,
                                aResult);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_WAITPROCESSED_RETURN(this, hrc, 0 /*normal*/, aTimeout, *aResult != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_WAITPROCESSED_RETURN(this, hrc, 1 /*hrc exception*/, aTimeout, *aResult != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_GUESTMULTITOUCHEVENT_WAITPROCESSED_RETURN(this, hrc, 9 /*unhandled exception*/, aTimeout, *aResult != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave aResult=%RTbool hrc=%Rhrc\n", this, "GuestMultiTouchEvent::waitProcessed", *aResult, hrc));
    return hrc;
}

//
// IGuestMultiTouchEvent methods
//

#ifdef VBOX_WITH_XPCOM
NS_DECL_CLASSINFO(GuestMultiTouchEventWrap)
NS_IMPL_THREADSAFE_ISUPPORTS2_CI(GuestMultiTouchEventWrap, IGuestMultiTouchEvent, IEvent)
#endif // VBOX_WITH_XPCOM

